
PROGRAM BPW_INSTALL;

(* Version 1.00 pour Windows 32 bits.

   Auteur               : Alcatz pour www.developpez.com
   Date de cration     : 22-04-2008.
   Dernire mise  jour : 25-05-2008.
   Compilateur          : Virtual Pascal 2.1 build 279.

   Installation automatise de BPW 7.0 (version prinstalle) *)


(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                              DIRECTIVES DE COMPILATION                                                 *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

{$R BPW_Inst.res}   (* Ressources *)


(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                               UNITES ET DLL UTILISEES                                                  *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Uses Strings,    (* Chanes AZT *)
     Windows,    (* API Win32 *)
     OWindows,   (* Objets fentres OWL *)
     ODialogs;   (* Objets dialogues et contrles OWL *)


(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                   CONSTANTES NON TYPEES (DIRECTIVES AU COMPILATEUR)                                    *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

{$I BPW_Inst.inc}   (* Identificateurs de ressources *)

Const (* ========== Chanes ========== *)

      NomApplication = 'BPW 7.0 setup';
      Masque         = '\*.*';

      (* ========== Langues ========== *)

      Francais   = 0;
      English    = 1;
      Nederlands = 2;
      Deutsch    = 3;

      (* ========== Etape du programme en cours ========== *)

      Intro        = 0;   (* 1er cran *)
      Installation = 1;   (* Installation en cours *)
      Fin          = 2;   (* Installation termine *)

      (* ========== API Shell32 et OLE32 ========== *)

      CSIDL_DESKTOPDIRECTORY = $0010;
      CLSCTX_INPROC_SERVER   = 1;
      CLSCTX_LOCAL_SERVER    = 4;


(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                                  DECLARATIONS DE TYPES                                                 *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Type (* ========== API Shell32 et OLE32 ========== *)

     pGUID = ^tGUID;
     tGUID = Packed Record
               Data1 : DWord;
               Data2 : SmallWord;
               Data3 : SmallWord;
               Data4 : Array [0..7] of Byte;
             end;
     pIID = pGUID;
     tIID = tGUID;
     pCLSID = pGUID;
     tCLSID = tGUID;

     SHITEMID = Record
                  cb : USHORT;
                  abID : Array [0..0] of Byte;
                end;
     LPSHITEMID = ^SHITEMID;
     LPCSHITEMID = ^SHITEMID;
     _SHITEMID = SHITEMID;
     TSHITEMID = SHITEMID;
     PSHITEMID = ^SHITEMID;
     ITEMIDLIST = Record
                    mkid : SHITEMID;
                  end;
     LPITEMIDLIST = ^ITEMIDLIST;
     LPCITEMIDLIST = ^ITEMIDLIST;
     _ITEMIDLIST = ITEMIDLIST;
     TITEMIDLIST = ITEMIDLIST;
     PITEMIDLIST = ^ITEMIDLIST;

{&StdCall+}
     BFFCALLBACK = Function (Wnd : HWnd; uMsg : UINT; lParam, lpData : lParam) : Integer;
     tFNBFFCallBack = BFFCALLBACK;
{&StdCall-}

     pBrowseInfoA = ^tBrowseInfoA;
     pBrowseInfoW = ^tBrowseInfoW;
     pBrowseInfo = pBrowseInfoA;
     _BrowseInfoA = Record
                      HWndOwner : HWnd;
                      pIdlRoot : pItemIDList;
                      pszDisplayName : pAnsiChar;
                      lpszTitle : pAnsiChar;
                      ulFlags : UINT;
                      lpfn : tFNBFFCallBack;
                      lParam : lParam;
                      iImage : Integer;
                    end;
     _BrowseInfoW = Record
                      HWndOwner : HWnd;
                      pIdlRoot : pItemIDList;
                      pszDisplayName : pWideChar;
                      lpszTitle : pWideChar;
                      ulFlags : UINT;
                      lpfn : tFNBFFCallBack;
                      lParam : lParam;
                      iImage : Integer;
                    end;
     _BrowseInfo = _BrowseInfoA;
     tBrowseInfoA = _BrowseInfoA;
     tBrowseInfoW = _BrowseInfoW;
     tBrowseInfo = tBrowseInfoA;
     BROWSEINFOA = _browseinfoA;
     BROWSEINFOW = _browseinfoW;
     BROWSEINFO = BROWSEINFOA;

     (* ========== Interfaces ========== *)

     ppIUnknown = ^pIUnknown;
     pIUnknown = ^IUnknown;
     IUnknown = Class
                Public
{&StdCall+}
                  Function QueryInterface (const iid : TIID; var Obj) : hResult;
                     virtual; stdcall; abstract;
                  Function AddRef : LongInt;
                     virtual; stdcall; abstract;
                  Function Release : LongInt;
                     virtual; stdcall; abstract;
{&StdCall-}
                end;

     ppIMalloc = ^pIMalloc;
     pIMalloc = ^IMalloc;
     IMalloc = Class (IUnknown)
               Public
{&StdCall+}
                 Function Alloc (cb : LongInt) : Pointer;
                    virtual; stdcall; abstract;
                 Function Realloc (pv : Pointer; cb : LongInt): Pointer;
                    virtual; stdcall; abstract;
                 Procedure Free (pv : Pointer);
                    virtual; stdcall; abstract;
                 Function GetSize (pv : Pointer) : LongInt;
                    virtual; stdcall; abstract;
                 Function DidAlloc (pv : Pointer) : Integer;
                    virtual; stdcall; abstract;
                 Procedure HeapMinimize;
                    virtual; stdcall; abstract;
{&StdCall-}
               end;

     IShellLinkA = Class (IUnknown)
                   Public
{&StdCall+}
                     Function GetArguments (pszArgs : pAnsiChar; cchMaxPath : Integer) : hResult;
                        virtual; stdcall; abstract;
                     Function GetDescription (pszName : pAnsiChar; cchMaxName : Integer) : hResult;
                        virtual; stdcall; abstract;
                     Function GetHotkey (var pwHotkey : Word) : hResult;
                        virtual; stdcall; abstract;
                     Function GetIconLocation (pszIconPath : pAnsiChar; cchIconPath : Integer; var piIcon : Integer) : hResult;
                        virtual; stdcall; abstract;
                     Function GetIDList (var ppidl : pItemIDList) : hResult;
                        virtual; stdcall; abstract;
                     Function GetPath (pszFile : pAnsiChar; cchMaxPath : Integer; var pfd : tWin32FindData; fFlags : DWord) : hResult;
                        virtual; stdcall; abstract;
                     Function GetShowCmd (var piShowCmd : Integer) : hResult;
                         virtual; stdcall; abstract;
                     Function GetWorkingDirectory (pszDir : pAnsiChar; cchMaxPath : Integer) : hResult;
                        virtual; stdcall; abstract;
                     Function Resolve (Wnd : HWnd; fFlags : DWord) : hResult;
                        virtual; stdcall; abstract;
                     Function SetArguments (pszArgs : pAnsiChar) : hResult;
                        virtual; stdcall; abstract;
                     Function SetDescription (pszName : pAnsiChar) : hResult;
                        virtual; stdcall; abstract;
                     Function SetHotkey (wHotkey : Word) : hResult;
                        virtual; stdcall; abstract;
                     Function SetIconLocation (pszIconPath : pAnsiChar; iIcon : Integer) : hResult;
                        virtual; stdcall; abstract;
                     Function SetIDList (pidl : pItemIDList) : hResult;
                        virtual; stdcall; abstract;
                     Function SetPath (pszFile : pAnsiChar) : hResult;
                        virtual; stdcall; abstract;
                     Function SetRelativePath (pszPathRel : pAnsiChar; dwReserved : DWord) : hResult;
                        virtual; stdcall; abstract;
                     Function SetShowCmd (iShowCmd : Integer) : hResult;
                        virtual; stdcall; abstract;
                     Function SetWorkingDirectory (pszDir : pAnsiChar) : hResult;
                        virtual; stdcall; abstract;
{&StdCall-}
                   end;
     IShellLinkW = Class (IUnknown)
                   Public
{&StdCall+}
                     Function GetArguments (pszArgs : pWideChar; cchMaxPath : Integer) : hResult;
                        virtual; stdcall; abstract;
                     Function GetDescription (pszName : pWideChar; cchMaxName : Integer) : hResult;
                        virtual; stdcall; abstract;
                     Function GetHotkey (var pwHotkey : Word) : hResult;
                        virtual; stdcall; abstract;
                     Function GetIconLocation (pszIconPath : pWideChar; cchIconPath : Integer; var piIcon : Integer) : hResult;
                        virtual; stdcall; abstract;
                     Function GetIDList (var ppidl : pItemIDList) : hResult;
                        virtual; stdcall; abstract;
                     Function GetPath (pszFile : pWideChar; cchMaxPath : Integer; var pfd : tWin32FindData; fFlags : DWord) : hResult;
                        virtual; stdcall; abstract;
                     Function GetShowCmd (var piShowCmd : Integer) : hResult;
                         virtual; stdcall; abstract;
                     Function GetWorkingDirectory (pszDir : pWideChar; cchMaxPath : Integer) : hResult;
                        virtual; stdcall; abstract;
                     Function Resolve (Wnd : HWnd; fFlags : DWord) : hResult;
                        virtual; stdcall; abstract;
                     Function SetArguments (pszArgs : pWideChar) : hResult;
                        virtual; stdcall; abstract;
                     Function SetDescription (pszName : pWideChar) : hResult;
                        virtual; stdcall; abstract;
                     Function SetHotkey (wHotkey : Word) : hResult;
                        virtual; stdcall; abstract;
                     Function SetIconLocation (pszIconPath : pWideChar; iIcon : Integer) : hResult;
                        virtual; stdcall; abstract;
                     Function SetIDList (pidl : pItemIDList) : hResult;
                        virtual; stdcall; abstract;
                     Function SetPath (pszFile : pWideChar) : hResult;
                        virtual; stdcall; abstract;
                     Function SetRelativePath (pszPathRel : pWideChar; dwReserved : DWord) : hResult;
                        virtual; stdcall; abstract;
                     Function SetShowCmd (iShowCmd : Integer) : hResult;
                        virtual; stdcall; abstract;
                     Function SetWorkingDirectory (pszDir : pWideChar) : hResult;
                        virtual; stdcall; abstract;
{&StdCall-}
                   end;
     ppIShellLink = ^pIShellLink;
     pIShellLink = ^IShellLink;
     IShellLink = IShellLinkA;

     ppIPersist = ^pIPersist;
     pIPersist = ^IPersist;
     IPersist = Class (IUnknown)
                Public
{&StdCall+}
                  Function GetClassID (var ClassID : TCLSID) : hResult;
                     virtual; stdcall; abstract;
{&StdCall-}
                end;

     pOleStr = pWideChar;

     ppIPersistFile = ^pIPersistFile;
     pIPersistFile = ^IPersistFile;
     IPersistFile = Class (IPersist)
                    Public
{&StdCall+}
                      Function IsDirty : hResult;
                         virtual; stdcall; abstract;
                      Function Load (pszFileName : pOleStr; dwMode : LongInt) : hResult;
                         virtual; stdcall; abstract;
                      Function Save (pszFileName : pOleStr; fRemember : BOOL) : hResult;
                         virtual; stdcall; abstract;
                      Function SaveCompleted (pszFileName : pOleStr) : hResult;
                         virtual; stdcall; abstract;
                      Function GetCurFile (var pszFileName : pOleStr) : hResult;
                         virtual; stdcall; abstract;
{&StdCall-}
                    end;

     (* ========== Bote liste d'affichage des dtails ========== *)

     pListeDetails = ^tListeDetails;
     tListeDetails = Object(tListBox)
                       Constructor INIT (aParent : pWindowsObject; AnId : Integer; x, y, w, h : Integer);
                          (* Dfinition du style *)
                     end;

     (* ========== Fentre principale ========== *)

     pFenetrePrincipale = ^tFenetrePrincipale;
     tFenetrePrincipale = Object(tWindow)
                            PinceauFond : hBrush;                                 (* Couleur de fond *)
                            FonteCtl : hFont;                                     (* Police  utiliser par les contrles *)
                            RB_FR, RB_UK, RB_NL, RB_DE : pRadioButton;            (* Adresses des boutons radio *)
                            CB_Bin, CB_RTL, CB_Exemples, CB_Bureau : pCheckBox;   (* Adresses cases  cocher dossiers  installer *)
                            Edit_Dossier : pEdit;                                 (* Adresse du champ edit du dossier d'installation *)
                            Btn_Modifier, Btn_Quitter, Btn_Suivant : pButton;     (* Adresses des boutons *)
                            LB_Detail : pListeDetails;                            (* Adresse de la liste d'affichage des dtails *)
                            Langue : DWord;                                       (* Langue actuelle *)
                            DossierInstall : Array [0..MAX_PATH] of Char;         (* Dossier d'installation *)
                            Etape : DWord;                                        (* Indique quelle tape est en cours *)
                            Annulation : LongBool;                                (* Annulation de l'installation par l'utilisateur ? *)
                            Constructor INIT;
                               (* Taille de la fentre - Cration du pinceau pour le fond *)
                            Function GETCLASSNAME : pChar; virtual;
                               (* Retourne le nom de classe de la fentre *)
                            Procedure GETWINDOWCLASS (var aWndClass : tWndClass); virtual;
                               (* Icne de classe et couleur de fond *)
                            Procedure SETUPWINDOW; virtual;
                               (* Cochage des options par dfaut - Changement de la police de caractres des contrles *)
                            Procedure PAINT (PaintDC : hDC; var PaintInfo : tPaintStruct); virtual;
                               (* Affichage du texte et des images de la fentre *)
                            Procedure WMCOMMAND (var Msg : tMessage); virtual wm_First + wm_Command;
                               (* Changement de langue *)
                            Procedure IDBTNMODIFIER (var Msg : tMessage); virtual id_First + id_BtnModifier;
                               (* Choix du dossier d'installation *)
                            Procedure MESSAGE_OK (Index : DWord);
                               (* Ajout de 'OK'  la suite de l'item Index dans la liste de dtails *)
                            Procedure MESSAGE_ERREUR (Index : DWord);
                               (* Ajout de 'Erreur'  la suite de l'item Index dans la liste de dtails *)
                            Procedure MESSAGE_EXISTE_DEJA (Index : DWord);
                               (* Ajout de 'Existe dj'  la suite de l'item Index dans la liste de dtails *)
                            Function MESSAGE_CREATION_DOSSIER (Dossier : pChar) : DWord;
                               (* Ajout d'un item "Cration + [Dossier]" dans la liste de dtails *)
                            Function MESSAGE_COPIE_FICHIER (Fichier : pChar) : DWord;
                               (* Ajout d'un item "Copie + [Fichier]" dans la liste de dtails *)
                            Function MESSAGE_CREATION_FICHIER_INI : DWord;
                               (* Ajout d'un item "Cration du fichier BPW.INI" dans la liste de dtails *)
                            Function MESSAGE_CREATION_RACCOURCI : DWord;
                               (* Ajout d'un item "Cration d'un raccourci sur le bureau" dans la liste de dtails *)
                            Function MESSAGE_CREATION_FICHIER_CFG : DWord;
                               (* Ajout d'un item "Cration du fichier BPW.CFG" dans la liste de dtails *)
                            Function COPIE_FICHIERS : LongBool;
                               (* Copie des fichiers dans le dossier cible *)
                            Function CREATION_FICHIER_INI : LongBool;
                               (* Cration du fichier BPW.INI dans le dossier de Windows *)
                            Function CREATION_RACCOURCI : LongBool;
                               (* Cration du raccourci sur le bureau *)
                            Function CREATION_FICHIER_CFG : LongBool;
                               (* Cration du fichier BPW.CFG (dans le mme dossier que l'excutable BPW.EXE) *)
                            Function INSTALLATION_BPW : LongBool;
                               (* Ensemble des oprations d'installation *)
                            Procedure IDBTNSUIVANT (var Msg : tMessage); virtual id_First + id_BtnSuivant;
                               (* Dmarrage de l'installation *)
                            Procedure IDBTNQUITTER (var Msg : tMessage); virtual id_First + id_BtnQuitter;
                               (* Fin du programme *)
                            Destructor DONE; virtual;
                               (* Destruction du pinceau pour le fond *)
                          end;

     (* ========== Programme principal ========== *)

     tProgramme = Object(tApplication)
                    Procedure INITMAINWINDOW; virtual;
                       (* Allocation de la fentre principale *)
                  end;


(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                                  CONSTANTES TYPEES                                                     *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Const (* ========== API Shell32 et OLE32 ========== *)

      CLSID_ShellLink : tGUID  = (Data1 : $00021401; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IShellLink : tGUID   = (Data1 : $000214EE; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));
      IID_IPersistFile : tGUID = (Data1 : $0000010B; Data2 : $0000; Data3 : $0000; Data4 : ($C0,$00,$00,$00,$00,$00,$00,$46));


(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                                  VARIABLES GLOBALES                                                    *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Var (* ========== Programme principal ========== *)

    Programme : tProgramme;


Texte : Array [0..2047] of Char;   // A supprimer


(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                                PROCEDURES ET FONCTIONS                                                 *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

{&StdCall+}
Function CoInitialize (pvReserved : Pointer) : hResult;
   external 'ole32' name 'CoInitialize';
Procedure CoUninitialize;
   external 'ole32' name 'CoUninitialize';
Function CoCreateInstance (const clsid : TCLSID; unkOuter : IUnknown; dwClsContext : LongInt; const iid : TIID; var pv) : hResult;
   external 'ole32' name 'CoCreateInstance';
Function SHGetMalloc (ppMalloc : ppIMalloc) : hResult;
   external 'shell32.dll' name 'SHGetMalloc';
Function SHBrowseForFolder (lpbi : pBrowseInfo) : pItemIDList;
   external 'shell32' name 'SHBrowseForFolder';
Function SHGetSpecialFolderLocation (HWndOwner : HWnd; nFolder : Integer; var ppidl : pItemIDList) : hResult;
   external 'shell32.dll' name 'SHGetSpecialFolderLocation';
Function SHGetPathFromIDList (pidl : pItemIDList; pszPath : pChar) : BOOL;
   external 'shell32' name 'SHGetPathFromIDList';
{&StdCall-}

(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                             METHODES DE L'OBJET tListeDetail                                           *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Constructor tListeDetails.INIT (aParent : pWindowsObject; AnId : Integer; x, y, w, h : Integer);
(* Dfinition du style *)
Begin
  tListBox.INIT(aParent,AnId,x,y,w,h);
  Attr.Style := ws_Child or ws_Visible or lbs_NoIntegralHeight {or lbs_Notify} or ws_Border or ws_VSCroll;
End;


(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                          METHODES DE L'OBJET tFenetrePrincipale                                        *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Constructor tFenetrePrincipale.INIT;
(* Taille de la fentre - Cration du pinceau pour le fond - Cration des contrles - Initialisation des champs *)
Var c : Array [0..255] of Char;   (* Titre de la fentre ou d'un contrle *)
Begin
  LoadString(hInstance,id_StringTitre,c,SizeOf(c));
  tWindow.INIT(Nil,c);
  Attr.w := 364;
  Attr.h := 386;
  (* Initialisation des champs *)
  Langue := Francais;
  StrCopy(DossierInstall,'C:\BP7');
  Etape := Intro;
  Annulation := False;
  (* Cration du pinceau pour le fond *)
  PinceauFond := CreateSolidBrush(RGB(221,238,255));
  (* Police de caractres  utiliser par les contrles *)
  FonteCtl := GetStockObject(Ansi_Var_Font);
  (* Cration des contrles *)
  RB_FR := New(pRadioButton,INIT(@Self,id_RBFR,Nil,292,136,13,12,Nil));
  RB_UK := New(pRadioButton,INIT(@Self,id_RBUK,Nil,292,156,13,12,Nil));
  RB_NL := New(pRadioButton,INIT(@Self,id_RBNL,Nil,292,176,13,12,Nil));
  RB_DE := New(pRadioButton,INIT(@Self,id_RBDE,Nil,292,196,13,12,Nil));
  CB_Bin := New(pCheckBox,INIT(@Self,id_CBBin,Nil,16,180,13,13,Nil));
  CB_RTL := New(pCheckBox,INIT(@Self,id_CBRTL,Nil,16,200,13,13,Nil));
  CB_Exemples := New(pCheckBox,INIT(@Self,id_CBExemples,Nil,16,220,13,13,Nil));
  CB_Bureau := New(pCheckBox,INIT(@Self,id_CBBureau,Nil,16,240,13,13,Nil));
  Edit_Dossier := New(pEdit,INIT(@Self,id_EditDossier,DossierInstall,8,280,340,20,MAX_PATH,False));
  LoadString(hInstance,id_StringBtnModifier,c,SizeOf(c));
  Btn_Modifier := New(pButton,INIT(@Self,id_BtnModifier,c,264,248,84,28,False));
  LoadString(hInstance,id_StringBtnQuitter,c,SizeOf(c));
  Btn_Quitter := New(pButton,INIT(@Self,id_BtnQuitter,c,8,312,84,28,False));
  LoadString(hInstance,id_StringBtnSuivant,c,SizeOf(c));
  Btn_Suivant := New(pButton,INIT(@Self,id_BtnSuivant,c,264,312,84,28,False));
  LB_Detail := New(pListeDetails,INIT(@Self,id_LBDetail,6,135,344,164));
End;

Function tFenetrePrincipale.GETCLASSNAME : pChar;
(* Retourne le nom de classe de la fentre *)
Begin
  GETCLASSNAME := 'BPWSetupWindow';
End;

Procedure tFenetrePrincipale.GETWINDOWCLASS (var aWndClass : tWndClass);
(* Icne de classe et couleur de fond *)
Begin
  tWindow.GETWINDOWCLASS(aWndClass);
  aWndClass.hIcon := LoadIcon(hInstance,pChar(id_IconeFenetrePrincipale));
  aWndClass.hbrBackground := PinceauFond;
End;

Procedure tFenetrePrincipale.SETUPWINDOW;
(* Cochage des options par dfaut - Changement de la police de caractres des contrles *)
Begin
  tWindow.SETUPWINDOW;
  (* Cochage des boutons radio et des cases  cocher *)
  SendDlgItemMessage(hWindow,RB_FR^.Attr.Id,bm_SetCheck,1,0);
  SendDlgItemMessage(hWindow,CB_Bin^.Attr.Id,bm_SetCheck,1,0);
  EnableWindow(CB_Bin^.hWindow,False);
  SendDlgItemMessage(hWindow,CB_RTL^.Attr.Id,bm_SetCheck,1,0);
  SendDlgItemMessage(hWindow,CB_Exemples^.Attr.Id,bm_SetCheck,1,0);
  SendDlgItemMessage(hWindow,CB_Bureau^.Attr.Id,bm_SetCheck,1,0);
  (* Dfinition de la police  utiliser par les contrles *)
  SendDlgItemMessage(hWindow,Edit_Dossier^.Attr.Id,wm_SetFont,FonteCtl,MakeLParam(Word(True),0));
  SendDlgItemMessage(hWindow,Btn_Modifier^.Attr.Id,wm_SetFont,FonteCtl,MakeLParam(Word(True),0));
  SendDlgItemMessage(hWindow,Btn_Quitter^.Attr.Id,wm_SetFont,FonteCtl,MakeLParam(Word(True),0));
  SendDlgItemMessage(hWindow,Btn_Suivant^.Attr.Id,wm_SetFont,FonteCtl,MakeLParam(Word(True),0));
  SendDlgItemMessage(hWindow,LB_Detail^.Attr.Id,wm_SetFont,FonteCtl,MakeLParam(Word(True),0));
  (* Effacement de la zone d'affichage des dtails *)
  ShowWindow(LB_Detail^.hWindow,sw_Hide);
End;

Procedure tFenetrePrincipale.PAINT (PaintDC : hDC; var PaintInfo : tPaintStruct);
(* Affichage du texte et des images de la fentre *)
Var MemDC : hDC;                        (* Contexte d'affichage pour charger les images *)
    Bitmap, AncienneBitmap : hBitmap;   (* Ressource bitmap et ancienne bitmap slectionne dans MemDC *)
    AncienneFonte, Fonte : hFont;       (* Ancienne et nouvelle fontes *)
    AncienAlignement : UInt;            (* Ancien mode d'alignement du texte *)
    AncienModeFond : LongInt;           (* Ancien mode de traitement couleur de fond *)
    AncienneCouleur : tColorRef;        (* Ancienne couleur de texte ou de fond *)
    c : Array [0..255] of Char;         (* Chane  afficher *)
Begin
  (* Affichage des images *)
  MemDC := CreateCompatibleDC(PaintDC);
  Bitmap := LoadBitmap(hInstance,pChar(id_BitmapLogo));
  AncienneBitmap := SelectObject(MemDC,Bitmap);
  BitBlt(PaintDC,52,16,248,108,MemDC,0,0,SrcCopy);
  Bitmap := LoadBitmap(hInstance,pChar(id_BitmapFR));
  SelectObject(MemDC,Bitmap);
  BitBlt(PaintDC,310,135,15,13,MemDC,0,0,SrcCopy);
  Bitmap := LoadBitmap(hInstance,pChar(id_BitmapUK));
  SelectObject(MemDC,Bitmap);
  BitBlt(PaintDC,310,155,15,13,MemDC,0,0,SrcCopy);
  Bitmap := LoadBitmap(hInstance,pChar(id_BitmapNL));
  SelectObject(MemDC,Bitmap);
  BitBlt(PaintDC,310,175,15,13,MemDC,0,0,SrcCopy);
  Bitmap := LoadBitmap(hInstance,pChar(id_BitmapDE));
  SelectObject(MemDC,Bitmap);
  BitBlt(PaintDC,310,195,15,13,MemDC,0,0,SrcCopy);
  Bitmap := LoadBitmap(hInstance,pChar(id_BitmapSmile));
  SelectObject(MemDC,Bitmap);
  BitBlt(PaintDC,282,310,32,32,MemDC,0,0,SrcCopy);
  SelectObject(MemDC,AncienneBitmap);
  DeleteDC(MemDC);
  (* Affichage du texte *)
  Fonte := GetStockObject(Ansi_Var_Font);
  AncienneFonte := SelectObject(PaintDC,Fonte);
  AncienAlignement := SetTextAlign(PaintDC,ta_Top);
  AncienModeFond := SetBkMode(PaintDC,Transparent);
  AncienneCouleur := SetTextColor(PaintDC,RGB(64,0,128));
  LoadString(hInstance,id_StringExplication1 + Langue,c,SizeOf(c));
  TextOut(PaintDC,16,135,c,StrLen(c));
  LoadString(hInstance,id_StringExplication2 + Langue,c,SizeOf(c));
  TextOut(PaintDC,16,151,c,StrLen(c));
  LoadString(hInstance,id_StringCheckBin + Langue,c,SizeOf(c));
  TextOut(PaintDC,34,180,c,StrLen(c));
  LoadString(hInstance,id_StringCheckRTL + Langue,c,SizeOf(c));
  TextOut(PaintDC,34,200,c,StrLen(c));
  LoadString(hInstance,id_StringCheckExemples + Langue,c,SizeOf(c));
  TextOut(PaintDC,34,220,c,StrLen(c));
  LoadString(hInstance,id_StringCheckBureau + Langue,c,SizeOf(c));
  TextOut(PaintDC,34,240,c,StrLen(c));
  SetTextAlign(PaintDC,ta_Center or ta_Top);
  LoadString(hInstance,id_StringDVP,c,SizeOf(c));
  TextOut(PaintDC,178,318,c,StrLen(c));
  SetTextColor(PaintDC,AncienneCouleur);
  SetBkMode(PaintDC,AncienModeFond);
  SetTextAlign(PaintDC,AncienAlignement);
  SelectObject(PaintDC,AncienneFonte);
End;

Procedure tFenetrePrincipale.WMCOMMAND (var Msg : tMessage);
(* Changement de langue *)
Var c : Array [0..255] of Char;   (* Libell de bouton *)
Begin
  if (LoWord(Msg.wParam) in [id_RBFR..id_RBDE]) and (HiWord(Msg.wParam) = bn_Clicked)
     then
       begin
         Langue := LoWord(Msg.wParam) - id_RBFR;
         (* Mise  jour du libell des boutons *)
         LoadString(hInstance,id_StringBtnModifier + Langue,c,SizeOf(c));
         SetWindowText(Btn_Modifier^.hWindow,c);
         LoadString(hInstance,id_StringBtnQuitter + Langue,c,SizeOf(c));
         SetWindowText(Btn_Quitter^.hWindow,c);
         LoadString(hInstance,id_StringBtnSuivant + Langue,c,SizeOf(c));
         SetWindowText(Btn_Suivant^.hWindow,c);
         (* Mise  jour du texte de la fentre *)
         InvalidateRect(hWindow,Nil,True);
         UpdateWindow(hWindow);
       end
     else
       tWindow.WMCOMMAND(Msg);
End;

Procedure tFenetrePrincipale.IDBTNMODIFIER (var Msg : tMessage);
(* Choix du dossier d'installation *)
Var BrowseInfo : tBrowseInfo;        (* Structure utilise par SHBrowseForFolder *)
    ItemIdList : pItemIdList;        (* Item renvoy par SHBrowseForFolder *)
    Memory : IMalloc;                (* Objet mmoire allou pour le dossier d'installation *)
    c : pChar;                       (* Dossier d'installation *)
    Erreur : LongBool;               (* Erreur COM ? *)
    Titre : Array [0..15] of Char;   (* Titre du message d'erreur *)
    Texte : Array [0..79] of Char;   (* Titre du message d'erreur - Message du dialogue COM *)
Begin
  Erreur := False;
  if SHGetMalloc(@Memory) = NOERROR
     then
       begin
         c := Memory.Alloc(MAX_PATH);
         if c <> Nil
            then
              begin
                StrCopy(c,DossierInstall);
                FillChar(BrowseInfo,SizeOf(BrowseInfo),0);
                BrowseInfo.hWndOwner := GetFocus;
                BrowseInfo.pidlRoot := Nil;
                BrowseInfo.pszDisplayName := c;
                LoadString(hInstance,id_StringMsgDlgBrowse + Langue,Texte,SizeOf(Texte));
                BrowseInfo.lpszTitle := Texte;
                ItemIdList := SHBrowseForFolder(@BrowseInfo);
                if ItemIdList <> Nil
                   then
                     begin
                       SHGetPathFromIdList(ItemIdList,c);
                       StrCopy(DossierInstall,c);
                       Memory.Free(ItemIdList);
                     end
                   else
                     Erreur := True;
                Memory.Free(c);
              end
            else
              Erreur := True;
       end
     else
       Erreur := True;
  if not Erreur
     then   (* Mise  jour du contrle d'dition *)
       SendDlgItemMessage(hWindow,Edit_Dossier^.Attr.Id,wm_SetText,0,LongInt(@DossierInstall))
     else   (* Message d'erreur *)
       begin
         LoadString(hInstance,id_StringDlgBrowseErrorTitle + Langue,Titre,SizeOf(Titre));
         LoadString(hInstance,id_StringDlgBrowseErrorText + Langue,Texte,SizeOf(Texte));
         MessageBox(hWindow,Texte,Titre,mb_IconHand or mb_Ok);
       end;
End;

Procedure tFenetrePrincipale.MESSAGE_OK (Index : DWord);
(* Ajout de 'OK'  la suite de l'item Index dans la liste de dtails *)
Var c : Array [0..1023] of Char;   (* Chane  charger dans la bote liste *)
    d : Array [0..47] of Char;     (* Message prformat *)
Begin
  SendDlgItemMessage(hWindow,LB_Detail^.Attr.Id,lb_GetText,Index,LongInt(@c));
  LoadString(hInstance,id_StringMsgOK,d,SizeOf(d));
  StrCat(c,d);
  SendDlgItemMessage(hWindow,LB_Detail^.Attr.Id,lb_DeleteString,Index,0);
  SendDlgItemMessage(hWindow,LB_Detail^.Attr.Id,lb_AddString,0,LongInt(@c));
  SendDlgItemMessage(hWindow,LB_Detail^.Attr.Id,lb_SetTopIndex,Index,0);
End;

Procedure tFenetrePrincipale.MESSAGE_ERREUR (Index : DWord);
(* Ajout de 'Erreur'  la suite de l'item Index dans la liste de dtails *)
Var c : Array [0..1023] of Char;   (* Chane  charger dans la bote liste *)
    d : Array [0..47] of Char;     (* Message prformat *)
Begin
  SendDlgItemMessage(hWindow,LB_Detail^.Attr.Id,lb_GetText,Index,LongInt(@c));
  LoadString(hInstance,id_StringMsgErreur + Langue,d,SizeOf(d));
  StrCat(c,d);
  SendDlgItemMessage(hWindow,LB_Detail^.Attr.Id,lb_DeleteString,Index,0);
  SendDlgItemMessage(hWindow,LB_Detail^.Attr.Id,lb_AddString,0,LongInt(@c));
End;

Procedure tFenetrePrincipale.MESSAGE_EXISTE_DEJA (Index : DWord);
(* Ajout de 'Existe dj'  la suite de l'item Index dans la liste de dtails *)
Var c : Array [0..1023] of Char;   (* Chane  charger dans la bote liste *)
    d : Array [0..47] of Char;     (* Message prformat *)
Begin
  SendDlgItemMessage(hWindow,LB_Detail^.Attr.Id,lb_GetText,Index,LongInt(@c));
  LoadString(hInstance,id_StringMsgExisteDeja + Langue,d,SizeOf(d));
  StrCat(c,d);
  SendDlgItemMessage(hWindow,LB_Detail^.Attr.Id,lb_DeleteString,Index,0);
  SendDlgItemMessage(hWindow,LB_Detail^.Attr.Id,lb_AddString,0,LongInt(@c));
End;

Function tFenetrePrincipale.MESSAGE_CREATION_DOSSIER (Dossier : pChar) : DWord;
(* Ajout d'un item "Cration + [Dossier]" dans la liste de dtails *)
Var c : Array [0..1023] of Char;   (* Chane  charger dans la bote liste *)
Begin
  LoadString(hInstance,id_StringMsgCreation + Langue,c,SizeOf(c));
  StrCat(c,Dossier);
  MESSAGE_CREATION_DOSSIER := SendDlgItemMessage(hWindow,LB_Detail^.Attr.Id,lb_AddString,0,LongInt(@c));
End;

Function tFenetrePrincipale.MESSAGE_COPIE_FICHIER (Fichier : pChar) : DWord;
(* Ajout d'un item "Copie + [Fichier]" dans la liste de dtails *)
Var c : Array [0..1023] of Char;   (* Chane  charger dans la bote liste *)
Begin
  LoadString(hInstance,id_StringMsgCopie + Langue,c,SizeOf(c));
  StrCat(c,Fichier);
  MESSAGE_COPIE_FICHIER := SendDlgItemMessage(hWindow,LB_Detail^.Attr.Id,lb_AddString,0,LongInt(@c));
End;

Function tFenetrePrincipale.MESSAGE_CREATION_FICHIER_INI : DWord;
(* Ajout d'un item "Cration du fichier BPW.INI" dans la liste de dtails *)
Var c : Array [0..1023] of Char;   (* Chane  charger dans la bote liste *)
Begin
  LoadString(hInstance,id_StringMsgCreationINI + Langue,c,SizeOf(c));
  MESSAGE_CREATION_FICHIER_INI := SendDlgItemMessage(hWindow,LB_Detail^.Attr.Id,lb_AddString,0,LongInt(@c));
End;

Function tFenetrePrincipale.MESSAGE_CREATION_RACCOURCI : DWord;
(* Ajout d'un item "Cration d'un raccourci sur le bureau" dans la liste de dtails *)
Var c : Array [0..1023] of Char;   (* Chane  charger dans la bote liste *)
Begin
  LoadString(hInstance,id_StringMsgCreationRaccourci + Langue,c,SizeOf(c));
  MESSAGE_CREATION_RACCOURCI := SendDlgItemMessage(hWindow,LB_Detail^.Attr.Id,lb_AddString,0,LongInt(@c));
End;

Function tFenetrePrincipale.MESSAGE_CREATION_FICHIER_CFG : DWord;
(* Ajout d'un item "Cration du fichier BPW.CFG" dans la liste de dtails *)
Var c : Array [0..1023] of Char;   (* Chane  charger dans la bote liste *)
Begin
  LoadString(hInstance,id_StringMsgCreationCFG + Langue,c,SizeOf(c));
  MESSAGE_CREATION_FICHIER_CFG := SendDlgItemMessage(hWindow,LB_Detail^.Attr.Id,lb_AddString,0,LongInt(@c));
End;

Function tFenetrePrincipale.COPIE_FICHIERS : LongBool;
(* Copie des fichiers dans le dossier cible *)
Var DossierSource : Array [0..MAX_PATH] of Char;   (* Dossier source *)
    DossierDest : Array [0..MAX_PATH] of Char;     (* Dossier destination *)
    CheminSource : Array [0..MAX_PATH] of Char;    (* Buffer de construction du chemin source *)
    CheminDest : Array [0..MAX_PATH] of Char;      (* Buffer de construction du chemin de destination *)
    Continuer : LongBool;                          (* La copie peut-elle se poursuivre ? *)

          Function CREATION_DOSSIER (Dossier : pChar) : LongBool;
          (* Test de l'existence d'un dossier et, dans la ngative, cration de celui-ci *)
          Var FindData : tWin32FindData;   (* Structure de travail pour la recherche de fichier *)
              hRecherche : tHandle;        (* Handle de la session de recherche *)
              Index : DWord;               (* Index dans la bote liste des dtails *)
          Begin
            CREATION_DOSSIER := True;
            Index := MESSAGE_CREATION_DOSSIER(Dossier);
            (* Recherche si le rpertoire n'existe pas dj *)
            FillChar(FindData,SizeOf(FindData),0);
            hRecherche := FindFirstFile(Dossier,FindData);
            if hRecherche <> Invalid_Handle_Value
               then   (* Le dossier existe dj *)
                 begin
                   MESSAGE_EXISTE_DEJA(Index);
                   FindClose(hRecherche);
                 end
               else   (* Le dossier n'existe pas : le crer *)
                 if CreateDirectory(Dossier,Nil)
                    then
                      MESSAGE_OK(Index)
                    else
                      begin
                        MESSAGE_ERREUR(Index);
                        CREATION_DOSSIER := False;
                      end;
          End;

          Function COPIE_FICHIER (Source, Dest : pChar) : LongBool;
          (* Copie d'un fichier *)
          Var Index : DWord;   (* Index dans la bote liste des dtails *)
          Begin
            COPIE_FICHIER := True;
            Index := MESSAGE_COPIE_FICHIER(Dest);
            if CopyFile(Source,Dest,False)
               then
                 MESSAGE_OK(Index)
               else
                 begin
                   MESSAGE_ERREUR(Index);
                   COPIE_FICHIER := False;
                 end;
          End;

          Function COPIE_RECURSIVE (Source, Dest : pChar; SousRepertoires : LongBool) : LongBool;
          (* Copie rcursive des dossiers et fichiers vers le dossier de destination *)
          Var FindData : tWin32FindData;    (* Structure de travail pour la recherche de fichier *)
              hRecherche : tHandle;         (* Handle de la session de recherche *)
              DossierSourceSauve : pChar;   (* Dossier source sauvegard sur le tas *)
              DossierDestSauve : pChar;     (* Dossier destination sauvegard sur le tas *)
              ContinuerCopie : LongBool;    (* La recherche peut-elle tre poursuivie ? *)
              Erreur : LongBool;            (* Rsultat renvoy par la fonction *)
          Begin
            Erreur := False;
            ContinuerCopie := True;
            DossierSourceSauve := StrNew(Source);
            DossierDestSauve := StrNew(Dest);
            StrCopy(CheminSource,Source);
            StrCat(CheminSource,Masque);
            hRecherche := FindFirstFile(CheminSource,FindData);
            if hRecherche <> Invalid_Handle_Value
               then
                 begin
                   while ContinuerCopie and not Erreur do
                     begin
                       if (FindData.dwFileAttributes and File_Attribute_Directory) <> 0
                          then   (* Il s'agit d'un nom de dossier *)
                            begin
                              if SousRepertoires
                                 then   (* Copier galement les sous-rpertoires *)
                                   begin
                                     if FindData.cFileName[0] <> '.'
                                        then
                                          begin
                                            (* Cration du rpertoire destination *)
                                            StrCopy(CheminDest,DossierDestSauve);
                                            StrCat(CheminDest,'\');
                                            StrCat(CheminDest,FindData.cFileName);
                                            if CREATION_DOSSIER(CheminDest)
                                               then   (* Copie rcursive *)
                                                 begin
                                                   StrCopy(CheminSource,DossierSourceSauve);
                                                   StrCat(CheminSource,'\');
                                                   StrCat(CheminSource,FindData.cFileName);
                                                   Erreur := not COPIE_RECURSIVE(CheminSource,CheminDest,True);
                                                 end;
                                          end;
                                   end;
                            end
                          else   (* Il s'agit d'un fichier *)
                            begin
                              (* Construction du chemin source *)
                              StrCopy(CheminSource,DossierSourceSauve);
                              StrCat(CheminSource,'\');
                              Strcat(CheminSource,FindData.cFileName);
                              (* Construction du chemin destination *)
                              StrCopy(CheminDest,DossierDestSauve);
                              StrCat(CheminDest,'\');
                              Strcat(CheminDest,FindData.cFileName);
                              (* Copie du fichier *)
                              Erreur := not COPIE_FICHIER(CheminSource,CheminDest);
                            end;
                       if not Erreur
                          then
                            begin
                              ContinuerCopie := FindNextFile(hRecherche,FindData);
                              if not ContinuerCopie
                                 then
                                   Erreur := (GetLastError <> Error_No_More_Files);
                            end;
                     end;
                   FindClose(hRecherche);
                 end
               else
                 Erreur := True;
            if DossierSourceSauve <> Nil
               then
                 StrDispose(DossierSourceSauve);
            if DossierDestSauve <> Nil
               then
                 StrDispose(DossierDestSauve);
            (* Renvoi du rsultat des oprations *)
            COPIE_RECURSIVE := not Erreur;
          End;

Begin
  Continuer := True;
  (* Dtermination du dossier de destination *)
  SendDlgItemMessage(hWindow,Edit_Dossier^.Attr.Id,wm_GetText,SizeOf(DossierInstall),LongInt(@DossierInstall));
  if DossierInstall[StrLen(DossierInstall) - 1] = '\'
     then   (* Suppression du \ final *)
       DossierInstall[StrLen(DossierInstall) - 1] := #0;
  StrCopy(DossierDest,DossierInstall);
  (* Dtermination du dossier source *)
  GetCurrentDirectory(SizeOf(DossierSource),DossierSource);
  (* Dossier "racine" *)
  Continuer := CREATION_DOSSIER(DossierDest);
  if Continuer and not Annulation
     then
       Continuer := COPIE_RECURSIVE(DossierSource,DossierDest,False);
  (* Sous-dossier BGI *)
  if Continuer and not Annulation
     then
       begin
         StrCopy(CheminDest,DossierDest);
         StrCat(CheminDest,'\BGI');
         Continuer := CREATION_DOSSIER(CheminDest);
       end;
  if Continuer and not Annulation
     then
       begin
         StrCopy(CheminSource,DossierSource);
         StrCat(CheminSource,'\BGI');
         Continuer := COPIE_RECURSIVE(CheminSource,CheminDest,True);
       end;
  (* Sous-dossier BIN *)
  if Continuer and not Annulation
     then
       begin
         StrCopy(CheminDest,DossierDest);
         StrCat(CheminDest,'\BIN');
         Continuer := CREATION_DOSSIER(CheminDest);
       end;
  if Continuer and not Annulation
     then
       begin
         StrCopy(CheminSource,DossierSource);
         StrCat(CheminSource,'\BIN');
         Continuer := COPIE_RECURSIVE(CheminSource,CheminDest,True);
       end;
  (* Sous-dossier DOC *)
  if Continuer and not Annulation
     then
       begin
         StrCopy(CheminDest,DossierDest);
         StrCat(CheminDest,'\DOC');
         Continuer := CREATION_DOSSIER(CheminDest);
       end;
  if Continuer and not Annulation
     then
       begin
         StrCopy(CheminSource,DossierSource);
         StrCat(CheminSource,'\DOC');
         Continuer := COPIE_RECURSIVE(CheminSource,CheminDest,True);
       end;
  (* Sous-dossier EXAMPLES *)
  if SendDlgItemMessage(hWindow,CB_Exemples^.Attr.Id,bm_GetCheck,0,0) = bst_Checked
     then
       begin
         if Continuer and not Annulation
            then
              begin
                StrCopy(CheminDest,DossierDest);
                StrCat(CheminDest,'\EXAMPLES');
                Continuer := CREATION_DOSSIER(CheminDest);
              end;
         if Continuer and not Annulation
            then
              begin
                StrCopy(CheminSource,DossierSource);
                StrCat(CheminSource,'\EXAMPLES');
                Continuer := COPIE_RECURSIVE(CheminSource,CheminDest,True);
              end;
       end;
  (* Sous-dossier PENWIN *)
  if Continuer and not Annulation
     then
       begin
         StrCopy(CheminDest,DossierDest);
         StrCat(CheminDest,'\PENWIN');
         Continuer := CREATION_DOSSIER(CheminDest);
       end;
  if Continuer and not Annulation
     then
       begin
         StrCopy(CheminSource,DossierSource);
         StrCat(CheminSource,'\PENWIN');
         Continuer := COPIE_RECURSIVE(CheminSource,CheminDest,True);
       end;
  (* Sous-dossier RTL *)
  if SendDlgItemMessage(hWindow,CB_RTL^.Attr.Id,bm_GetCheck,0,0) = bst_Checked
     then
       begin
         if Continuer and not Annulation
            then
              begin
                StrCopy(CheminDest,DossierDest);
                StrCat(CheminDest,'\RTL');
                Continuer := CREATION_DOSSIER(CheminDest);
              end;
         if Continuer and not Annulation
            then
              begin
                StrCopy(CheminSource,DossierSource);
                StrCat(CheminSource,'\RTL');
                Continuer := COPIE_RECURSIVE(CheminSource,CheminDest,True);
              end;
       end;
  (* Sous-dossier UNITS *)
  if Continuer and not Annulation
     then
       begin
         StrCopy(CheminDest,DossierDest);
         StrCat(CheminDest,'\UNITS');
         Continuer := CREATION_DOSSIER(CheminDest);
       end;
  if Continuer and not Annulation
     then
       begin
         StrCopy(CheminSource,DossierSource);
         StrCat(CheminSource,'\UNITS');
         Continuer := COPIE_RECURSIVE(CheminSource,CheminDest,True);
       end;
  (* Rsultat de la fonction *)
  COPIE_FICHIERS := Continuer;
End;

Function tFenetrePrincipale.CREATION_FICHIER_INI : LongBool;
(* Cration du fichier BPW.INI dans le dossier de Windows *)
Var FichierIni : Array [0..MAX_PATH] of Char;   (* Nom du fichier Ini *)
    Section : Array [0..31] of Char;            (* Nom de section *)
    Cle : Array [0..31] of Char;                (* Nom de cl *)
    Valeur : Array [0..MAX_PATH] of Char;       (* Valeur de la cl *)
Begin
  GetWindowsDirectory(FichierIni,SizeOf(FichierIni));
  StrCat(FichierIni,'BPW.INI');
  StrCopy(Section,'Startup');
  StrCopy(Cle,'CfgPath');
  GetShortPathName(DossierInstall,Valeur,SizeOf(Valeur));   (* Nom MS-DOS ! *)
  StrCat(Valeur,'\BIN\BPW.CFG');
  CREATION_FICHIER_INI := WritePrivateProfileString(Section,Cle,Valeur,FichierIni);
End;

Function tFenetrePrincipale.CREATION_RACCOURCI : LongBool;
(* Cration du raccourci sur le bureau *)
Var Bureau : Array [0..MAX_PATH] of Char;   (* Chemin vers le bureau de l'utilisateur courant *)
    c : Array [0..MAX_PATH] of Char;        (* Chemin  charger dans les proprits du raccourci *)
    w : Array [0..MAX_PATH] of WChar;       (* Version Unicode de c *)
    pIdL : pItemIdList;                     (* Rsultat de SHGetSpecialFolderLocation *)
    ShellLink : IShellLink;                 (* Shell link object *)
    PersistFile : IPersistFile;             (* Shell file object *)
Begin
  CREATION_RACCOURCI := True;
  if (SHGetSpecialFolderLocation(0,CSIDL_DESKTOPDIRECTORY,pIdL) = NOERROR) and SHGetPathFromIDList(pIdL,Bureau)
     then
       begin
         if CoInitialize(Nil) = s_Ok
            then
              begin
                if CoCreateInstance(CLSID_ShellLink,Nil,CLSCTX_INPROC_SERVER or CLSCTX_LOCAL_SERVER,IID_IShellLink,ShellLink) = s_Ok
                   then
                     begin
                       if ShellLink.QueryInterface(IID_IPersistFile,PersistFile) = s_Ok
                          then
                            begin
                              StrCopy(c,DossierInstall);
                              StrCat(c,'\BIN\BPW.EXE');
                              if ShellLink.SetWorkingDirectory(c) = s_OK
                                 then
                                   begin
                                     StrCopy(c,Bureau);
                                     StrCat(c,'\BPW.lnk');
                                     MultiByteToWideChar(CP_ACP,0,c,-1,@w,SizeOf(w));
                                     if PersistFile.Save(@w,False) <> s_Ok
                                        then
                                          CREATION_RACCOURCI := False;
                                   end
                                 else
                                   CREATION_RACCOURCI := False;
                              PersistFile.Release;
                            end
                          else
                            CREATION_RACCOURCI := False;
                       ShellLink.Release;
                     end
                   else
                     CREATION_RACCOURCI := False;
                CoUninitialize;
              end
            else
              CREATION_RACCOURCI := False;
       end;
End;

Function tFenetrePrincipale.CREATION_FICHIER_CFG : LongBool;
(* Cration du fichier BPW.CFG (dans le mme dossier que l'excutable BPW.EXE) *)
Var CheminDest : Array [0..MAX_PATH] of Char;   (* Chemin du fichier  crer *)
    Chemin : Array [0..MAX_PATH] of Char;       (* Chemin  construire *)
    HandleFichier : tHandle;                    (* Handle du fichier *)
    NbBytesEcrits : DWord;                      (* Nombre de bytes crits dans le fichier lors de la dernire opration *)
    OkCreation : LongBool;                      (* Rsultat de la cration du fichier *)
    OkEcriture : LongBool;                      (* Rsultat de l'criture dans le fichier *)
    OkFermeture : LongBool;                     (* Rsultat de la fermeture du fichier *)
    c : Array [0..511] of Char;                 (* Texte  crire dans le fichier *)
Begin
  StrCopy(CheminDest,DossierInstall);
  StrCat(CheminDest,'\BIN\BPW.CFG');
  HandleFichier := CreateFile(CheminDest,GENERIC_WRITE,FILE_SHARE_WRITE,Nil,CREATE_ALWAYS,FILE_ATTRIBUTE_ARCHIVE,0);
  OkCreation := (HandleFichier <> INVALID_HANDLE_VALUE);
  if OkCreation
     then
       begin
         StrCopy(c,'/E'#13#10'/I'#13#10'/O'#13#10'/R');
         GetShortPathName(DossierInstall,Chemin,SizeOf(Chemin));   (* Noms MS-DOS ! *)
         StrCat(c,Chemin);
         StrCat(c,'\UNITS;');
         OkEcriture := WriteFile(HandleFichier,c,StrLen(c),NbBytesEcrits,Nil);
         if OkEcriture
            then
              begin
                StrCopy(c,'/U');
                StrCat(c,Chemin);
                StrCat(c,'\UNITS;');
                OkEcriture := WriteFile(HandleFichier,c,StrLen(c),NbBytesEcrits,Nil);
              end;
         if OkEcriture
            then
              begin
                StrCopy(c,'/$CW'#13#10'/$DA+'#13#10'/$DB-'#13#10'/$DD+'#13#10'/$DE+'#13#10'/$DF-'#13#10'/$DG-'#13#10'/$DI+'#13#10);
                OkEcriture := WriteFile(HandleFichier,c,StrLen(c),NbBytesEcrits,Nil);
              end;
         if OkEcriture
            then
              begin
                StrCopy(c,'/$DK-'#13#10'/$DL+'#13#10'/$DN-'#13#10'/$DO-'#13#10'/$DP-'#13#10'/$DQ-'#13#10'/$DR-'#13#10'/$DS+'#13#10);
                OkEcriture := WriteFile(HandleFichier,c,StrLen(c),NbBytesEcrits,Nil);
              end;
         if OkEcriture
            then
              begin
                StrCopy(c,'/$DT-'#13#10'/$DV+'#13#10'/$DW-'#13#10'/$DX+'#13#10'/$DY+'#13#10'/$DM16384,0,655360'#13#10'/D~D'#13#10);
                OkEcriture := WriteFile(HandleFichier,c,StrLen(c),NbBytesEcrits,Nil);
              end;
         if OkEcriture
            then
              begin
                StrCopy(c,'/$PA+'#13#10'/$PB-'#13#10'/$PD+'#13#10'/$PE+'#13#10'/$PF-'#13#10'/$PG+'#13#10'/$PI+'#13#10'/$PK-'#13#10);
                OkEcriture := WriteFile(HandleFichier,c,StrLen(c),NbBytesEcrits,Nil);
              end;
         if OkEcriture
            then
              begin
                StrCopy(c,'/$PL+'#13#10'/$PN-'#13#10'/$PO-'#13#10'/$PP-'#13#10'/$PQ-'#13#10'/$PR-'#13#10'/$PS+'#13#10'/$PT-'#13#10);
                OkEcriture := WriteFile(HandleFichier,c,StrLen(c),NbBytesEcrits,Nil);
              end;
         if OkEcriture
            then
              begin
                StrCopy(c,'/$PV+'#13#10'/$PW-'#13#10'/$PX+'#13#10'/$PY+'#13#10'/$PM16384,0,0'#13#10'/D~P'#13#10'/$WA+'#13#10'/$WB-'#13#10);
                OkEcriture := WriteFile(HandleFichier,c,StrLen(c),NbBytesEcrits,Nil);
              end;
         if OkEcriture
            then
              begin
                StrCopy(c,'/$WD+'#13#10'/$WE-'#13#10'/$WF-'#13#10'/$WG+'#13#10'/$WI+'#13#10'/$WK+'#13#10'/$WL+'#13#10'/$WN-'#13#10);
                OkEcriture := WriteFile(HandleFichier,c,StrLen(c),NbBytesEcrits,Nil);
              end;
         if OkEcriture
            then
              begin
                StrCopy(c,'/$WO-'#13#10'/$WP-'#13#10'/$WQ-'#13#10'/$WR-'#13#10'/$WS+'#13#10'/$WT-'#13#10'/$WV+'#13#10'/$WW+'#13#10);
                OkEcriture := WriteFile(HandleFichier,c,StrLen(c),NbBytesEcrits,Nil);
              end;
         if OkEcriture
            then
              begin
                StrCopy(c,'/$WX+'#13#10'/$WY+'#13#10'/$WM8192,8192,0'#13#10'/D~W'#13#10'/#P'#13#10'/#C'#13#10'/#AE-'#13#10'/#AD+'#13#10);
                OkEcriture := WriteFile(HandleFichier,c,StrLen(c),NbBytesEcrits,Nil);
              end;
         if OkEcriture
            then
              begin
                StrCopy(c,'/#AC+'#13#10'/#AT-'#13#10'/#AS+'#13#10'/#EF+'#13#10'/#EI+'#13#10'/#EA+'#13#10'/#EU-'#13#10'/#EO+'#13#10);
                OkEcriture := WriteFile(HandleFichier,c,StrLen(c),NbBytesEcrits,Nil);
              end;
         if OkEcriture
            then
              begin
                StrCopy(c,'/#EB-'#13#10'/#EC+'#13#10'/#EG+'#13#10'/#EK-'#13#10'/#EV+'#13#10'/#EH+'#13#10'/#ET8'#13#10'/#ESC'#13#10);
                OkEcriture := WriteFile(HandleFichier,c,StrLen(c),NbBytesEcrits,Nil);
              end;
         if OkEcriture
            then
              begin
                StrCopy(c,'/#EX*.pas;*.inc'#13#10'/#F"Courier New",13,0'#13#10'/#MH'#13#10'/#RO'#13#10'/#W-'#13#10'/#SB-'#13#10);
                OkEcriture := WriteFile(HandleFichier,c,StrLen(c),NbBytesEcrits,Nil);
              end;
         if OkEcriture
            then
              begin
                StrCopy(c,'/#SI+'#13#10'/#SR-'#13#10'/#SW-'#13#10'/#SE+'#13#10'/#SS-'#13#10'/#SP+'#13#10'/@SL+'#13#10'/@SC+'#13#10);
                OkEcriture := WriteFile(HandleFichier,c,StrLen(c),NbBytesEcrits,Nil);
              end;
         if OkEcriture
            then
              begin
                StrCopy(c,'/@ST+'#13#10'/@SV+'#13#10'/@SP+'#13#10'/@SF+'#13#10'/@SI+'#13#10'/@SU+'#13#10'/@SR+'#13#10'/@DN-'#13#10);
                OkEcriture := WriteFile(HandleFichier,c,StrLen(c),NbBytesEcrits,Nil);
              end;
         if OkEcriture
            then
              begin
                StrCopy(c,'/^0 0 0 0 1 19 1'#13#10'/^1 0 0 0 1 19 1'#13#10'/^2 2 0 13 0 19 1'#13#10'/^3 1 0 0 1 19 1'#13#10);
                OkEcriture := WriteFile(HandleFichier,c,StrLen(c),NbBytesEcrits,Nil);
              end;
         if OkEcriture
            then
              begin
                StrCopy(c,'/^4 0 0 0 1 19 1'#13#10'/^5 0 0 0 1 19 1'#13#10'/^6 2 0 17 0 19 1'#13#10'/^7 0 0 0 0 19 1'#13#10'/^8 0 0 16 0 19 1');
                OkEcriture := WriteFile(HandleFichier,c,StrLen(c),NbBytesEcrits,Nil);
              end;
         OkFermeture := CloseHandle(HandleFichier);
       end;
  (* Rsultat de la fonction *)
  CREATION_FICHIER_CFG := OkCreation and OkEcriture and OkFermeture;
End;

Function tFenetrePrincipale.INSTALLATION_BPW : LongBool;
(* Ensemble des oprations d'installation *)
Var Index : DWord;   (* Index dans la bote liste des dtails *)
Begin
  INSTALLATION_BPW := True;
  if COPIE_FICHIERS
     then
       if not Annulation
          then
            begin
              Index := MESSAGE_CREATION_FICHIER_INI;
              if CREATION_FICHIER_INI
                 then
                   begin
                     MESSAGE_OK(Index);
                     if not Annulation
                        then
                          begin
                            Index := MESSAGE_CREATION_RACCOURCI;
                            if CREATION_RACCOURCI
                               then
                                 begin
                                   MESSAGE_OK(Index);
                                   if not Annulation
                                      then
                                        begin
                                          Index := MESSAGE_CREATION_FICHIER_CFG;
                                          if CREATION_FICHIER_CFG
                                             then
                                               MESSAGE_OK(Index)
                                             else
                                               begin
                                                 MESSAGE_ERREUR(Index);
                                                 INSTALLATION_BPW := False;
                                               end;
                                        end
                                      else
                                        INSTALLATION_BPW := False;
                                 end
                               else
                                 begin
                                   MESSAGE_ERREUR(Index);
                                   INSTALLATION_BPW := False;
                                 end;
                          end
                        else
                          INSTALLATION_BPW := False;
                   end
                 else
                   begin
                     MESSAGE_ERREUR(Index);
                     INSTALLATION_BPW := False;
                   end;
            end
          else
            INSTALLATION_BPW := False;
End;

Procedure tFenetrePrincipale.IDBTNSUIVANT (var Msg : tMessage);
(* Dmarrage de l'installation *ou* annulation *ou* retour en arrire *)
Var c : Array [0..255] of Char;                (* Chane  afficher *)
    Dossier83 : Array [0..MAX_PATH] of Char;   (* Dossier d'installation au format 8.3 *)
Begin
  case Etape of
    Intro : begin   (* Dmarrage de l'installation *)
              Etape := Installation;
              (* Effacement des contrles affichs *)
              ShowWindow(RB_FR^.hWindow,sw_Hide);
              ShowWindow(RB_UK^.hWindow,sw_Hide);
              ShowWindow(RB_NL^.hWindow,sw_Hide);
              ShowWindow(RB_DE^.hWindow,sw_Hide);
              ShowWindow(CB_Bin^.hWindow,sw_Hide);
              ShowWindow(CB_RTL^.hWindow,sw_Hide);
              ShowWindow(CB_Exemples^.hWindow,sw_Hide);
              ShowWindow(CB_Bureau^.hWindow,sw_Hide);
              ShowWindow(Edit_Dossier^.hWindow,sw_Hide);
              ShowWindow(Btn_Modifier^.hWindow,sw_Hide);
              (* Affichage de la zone de dtails (vide) *)
              ShowWindow(LB_Detail^.hWindow,sw_Show);
              SendDlgItemMessage(hWindow,LB_Detail^.Attr.Id,lb_ResetContent,0,0);
              (* Changement du libell du bouton "suivant >>" en "Annuler" *)
              LoadString(hInstance,id_StringBtnAnnuler + Langue,c,SizeOf(c));
              SetWindowText(Btn_Suivant^.hWindow,c);
              (* Dsactivation du bouton "Quitter" *)
              EnableWindow(Btn_Quitter^.hWindow,False);
              (* Installation *)
              Etape := Fin;
              if INSTALLATION_BPW
                 then   (* OK : effacement du bouton au profit du smiley *)
                   ShowWindow(Btn_Suivant^.hWindow,sw_Hide)
                 else   (* Erreur : changement du libell du bouton "Annuler" en "<< Prcdent" *)
                   begin
                     LoadString(hInstance,id_StringBtnPrec + Langue,c,SizeOf(c));
                     SetWindowText(Btn_Suivant^.hWindow,c);
                   end;
              (* Ractivation du bouton "Quitter" *)
              EnableWindow(Btn_Quitter^.hWindow,True);
            end;
    Installation : begin   (* Annulation de l'installation *)
                     Etape := Fin;
                     (* Changement du libell du bouton "Annuler" en "<< Prcdent" *)
                     LoadString(hInstance,id_StringBtnPrec + Langue,c,SizeOf(c));
                     SetWindowText(Btn_Suivant^.hWindow,c);
                     (* Ractivation du bouton "Quitter" *)
                     EnableWindow(Btn_Quitter^.hWindow,True);
                   end;
    Fin : begin   (* Retour au 1er cran *)
            Annulation := True;
            Etape := Intro;
            (* Effacement de la zone de dtails *)
            ShowWindow(LB_Detail^.hWindow,sw_Hide);
            (* Affichage des autres contrles *)
            ShowWindow(RB_FR^.hWindow,sw_Show);
            ShowWindow(RB_UK^.hWindow,sw_Show);
            ShowWindow(RB_NL^.hWindow,sw_Show);
            ShowWindow(RB_DE^.hWindow,sw_Show);
            ShowWindow(CB_Bin^.hWindow,sw_Show);
            ShowWindow(CB_RTL^.hWindow,sw_Show);
            ShowWindow(CB_Exemples^.hWindow,sw_Show);
            ShowWindow(CB_Bureau^.hWindow,sw_Show);
            ShowWindow(Edit_Dossier^.hWindow,sw_Show);
            ShowWindow(Btn_Modifier^.hWindow,sw_Show);
            (* Changement du libell du bouton "Annuler" en "<< Prcdent" *)
            LoadString(hInstance,id_StringBtnSuivant + Langue,c,SizeOf(c));
            SetWindowText(Btn_Suivant^.hWindow,c);
          end;
  end;
End;

Procedure tFenetrePrincipale.IDBTNQUITTER (var Msg : tMessage);
(* Fin du programme *)
Begin
  tWindow.CloseWindow;
End;

Destructor tFenetrePrincipale.DONE;
(* Destruction du pinceau pour le fond *)
Begin
  DeleteObject(PinceauFond);
  tWindow.DONE;
End;


(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                              METHODES DE L'OBJET tProgramme                                            *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

Procedure tProgramme.INITMAINWINDOW;
(* Allocation de la fentre principale *)
Begin
  MainWindow := New(pFenetrePrincipale,INIT);
End;


(* ---------------------------------------------------------------------------------------------------------------------- *)
(*                                                  PROGRAMME PRINCIPAL                                                   *)
(* ---------------------------------------------------------------------------------------------------------------------- *)

BEGIN
  Programme.INIT(NomApplication);
  Programme.RUN;
  Programme.DONE;
END.

